--[[============================================================================
main.lua
============================================================================]]--

-- requires
require 'globals'
require 'gui_controls'
require 'gui_preset_manager'
require 'gui_init'
require 'envelope_processing'
require 'preset_manager'



--clear_undo_folder()
--------------------------------------------------------------------------------
-- Helper functions in the globals.lua that you can find scattered around here:
-- math.round(value) -> rounds up values with .5 or higher, rounds down if lower.
-- toboolean(value) -> converts (string)values to true or false
-- table.serialize(table) -> concats table contents to a string
-- string:split(pattern) -> splits string to a table based on a Regex pattern
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- menu registration
--------------------------------------------------------------------------------

renoise.tool():add_menu_entry {
   name = "Instrument Box:"..MENU_TITLE,
   invoke = open_main_dialog
}

renoise.tool():add_menu_entry {
   name = "Sample List:"..MENU_TITLE,
   invoke = open_main_dialog
}

renoise.tool():add_keybinding {
  name = "Global:Tools:"..MENU_TITLE,
  invoke = open_main_dialog
}

renoise.tool():add_midi_mapping {
  name = "MidiTest:change line...",
  invoke = function (message) print(message.int_value) end
}

local file = get_tools_file()
TOOL_FILE = file:sub(1,file:find(".xrnx"))      
get_preset_list()

function init_tables(column)
  for t = 0,MAXIMUM_FRAME_LENGTH do
    if column == ENV_NOTE_COLUMN then
      env_note_value[t] = EMPTY_CELL
    elseif column == ENV_VOL_COLUMN then
      env_vol_value[t] = EMPTY_CELL
    elseif column == ENV_PAN_COLUMN then
      env_pan_value[t] = EMPTY_CELL
    elseif column == false then
      env_cut_value[t] = EMPTY_CELL
      env_res_value[t] = EMPTY_CELL
    end
  end

end
